//! # Admin action log

use crate::data::admin::AdminID;

#[derive(serde::Serialize, serde::Deserialize)]
pub enum AdminAction {
    AuthWithResetToken,
    AuthWithAccessKey { key: String, key_id: u64 },
    RegisteredAdminKey { name: String, target: AdminID },
    DeletedAdminKey { name: String, target: AdminID },
    GeneratedAdminResetToken { target: AdminID },
    CreatedAdmin { id: AdminID, name: String, email: String },
    UpdatedAdminGeneralSettings { target: AdminID, new_email: String, new_name: String },
    AddAdminRole { target: AdminID, role: String },
    RemoveAdminRole { target: AdminID, role: String },
    UnsupportedAction,
}


pub struct AdminActionLog {
    pub id: u64,
    pub admin_id: AdminID,
    pub ip: String,
    pub time: u64,
    pub action: AdminAction,
}